#
# This file was generated using xslt from its XML file
#
# Copyright 2009, Associated Universities Inc., Washington DC
#
import sys
import os
from  casac import *
import string
from taskinit import casalog
from taskinit import xmlpath
#from taskmanager import tm
import task_specflux
def specflux(imagename='', box='', region='', chans='', stokes='', mask='', stretch=False, unit='km/s', major='', minor='', logfile='', overwrite=False):

        """Report details of an image spectrum.
PARAMETER SUMMARY
imagename        Name of the input (CASA, FITS, MIRIAD) image
box              Rectangular region to select in direction plane. See "help par.box"
                 for details. Default is to use the entire direction plane.
region           Region selection. See "help par.region" for details. Default is to use
                 the full image.
chans            Channels to use. See "help par.chans" for details. Default is to use
                 all channels.
stokes           Stokes planes to use. See "help par.stokes" for details. Default is to use
                 all Stokes planes.
mask             Mask to use. See help par.mask. Default is none.
stretch          Stretch the input mask if necessary and possible. Only used if a mask is specified.
                 See help par.stretch.
unit             Unit to use for the abscissa. Must be conformant with a typical spectral axis unit
                 (ie something conformant with a velocity, frequency, or length). Velocity units may
                 only be used if the spectral coordinate has a rest frequency and if it is > 0.
logfile          Name of file to which to write tabular output. Default is to not write to a file.
overwrite        Controls if an already existing log file by the
                 same name can be overwritten. If true, the user is not prompted, the file
                 if it exists is automatically overwritten.
major            Major axis of overriding restoring beam. If specified, must be a valid quantity.
                 If specified, minor must also be specified. The overriding beam is used for
                 computing flux density values. Ignored if the image brightness units do not contain
                 "/beam".
minor            Minor axis of overriding restoring beam. If specified, must be a valid quantity.
                 If specified, major must also be specified. See help on parameter major for details.

This application retrieves details of an image spectrum which has been integrated over a specified
region (or the entire image if no region has been specified). The spectral flux is reported in
units flux density consistent with the image brightness unit times the specified spectral unit (eg,
Jy*km/s, K*arcsec2*km/s). If the units are K*arcsec2..., multiply the reported value by
2.3504430539098e-8*d*d, where d is the distance in pc, to convert to units of K*pc2... 
If provided, major and minor will be used to compute the beam size, and hence the per channel flux
densities, overriding the input image beam information, if present.

# write spectrum to file that has been integrated over
# rectangular region, using only pixels with non-negative values.
# if the log file already exists, overwrite it with the new data.
specflux(imagename="my.im", box="10,10,45,50", mask="my.im>=0", unit="km/s", logfile="my.log", overwrite=True)


        """

#
#    The following is work around to avoid a bug with current python translation
#
        mytmp = {}

        mytmp['imagename'] = imagename
        mytmp['box'] = box
        mytmp['region'] = region
        mytmp['chans'] = chans
        mytmp['stokes'] = stokes
        mytmp['mask'] = mask
        mytmp['stretch'] = stretch
        mytmp['unit'] = unit
        mytmp['major'] = major
        mytmp['minor'] = minor
        mytmp['logfile'] = logfile
        mytmp['overwrite'] = overwrite
	pathname='file:///'+os.environ.get('CASAPATH').split()[0]+'/xml/'
	trec = casac.utils().torecord(pathname+'specflux.xml')

        casalog.origin('specflux')
        if trec.has_key('specflux') and casac.utils().verify(mytmp, trec['specflux']) :
	    result = task_specflux.specflux(imagename, box, region, chans, stokes, mask, stretch, unit, major, minor, logfile, overwrite)

	else :
	  result = False
        return result
